package com.jscape.inet.ssh.protocol.v2.messages;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.util.HexFormat;
import com.jscape.util.net.connection.MessageConnection;

import static com.jscape.util.Parameters.assertNotNull;

/**
 * @author Alex Usun
 */
public class SshMsgUserAuthRequestUnknown
        extends SshMsgUserAuthRequest<SshMsgUserAuthRequestUnknown.Handler> {

    public final String method;
    public final byte[] data;

    public SshMsgUserAuthRequestUnknown(String username, String serviceName, String method, byte[] data) {
        super(username, serviceName);

        assertNotNull(method);
        this.method = method;

        assertNotNull(data);
        this.data = data;
    }

    @Override
    public Class handlerClass() {
        return Handler.class;
    }

    @Override
    public void accept(Handler handler, MessageConnection<Message> connection) {
        handler.handle(this, connection);
    }

    @Override
    public String toString() {
        return "SshMsgUserAuthRequestUnknown {"
               + "username='" + this.username + '\''
               + ", serviceName='" + this.serviceName + '\''
               + ", method='" + this.method + '\''
               + ", data=" + HexFormat.formatData(this.data)
               + '}';
    }

    public interface Handler
            extends Message.HandlerBase {

        void handle(SshMsgUserAuthRequestUnknown message, MessageConnection<Message> connection);

    }
}
